common/models/TestQuestion.php
<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "test_questions".
 *
 * @property int $id
 * @property int $id_test
 * @property string $text
 * @property int $pos
 * @property double $cost
 * @property string $timestamp
 */
class TestQuestion extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'test_questions';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id_test', 'text', 'pos'], 'required'],
            [['id_test', 'pos'], 'integer'],
            [['text'], 'string'],
            [['cost'], 'number'],
            [['timestamp'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('common/model/test', 'ID'),
            'id_test' => Yii::t('common/model/test', 'Id Test'),
            'text' => Yii::t('common/model/test', 'Text'),
            'pos' => Yii::t('common/model/test', 'Pos'),
            'cost' => Yii::t('common/model/test', 'Cost'),
            'timestamp' => Yii::t('common/model/test', 'Timestamp'),
        ];
    }

    public function getAnswers()
    {
        return $this->hasMany(TestQuestionAnswer::class, ['id_question' => 'id'])->orderBy(['pos' => SORT_ASC]);
    }
}

backend/controllers/TestQuestionController.php
<?php

namespace backend\controllers;

use Yii;
use common\models\TestQuestion;
use backend\models\TestQuestionSearch;
use yii\db\Query;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * TestQuestionController implements the CRUD actions for TestQuestion model.
 */
class TestQuestionController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all TestQuestion models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new TestQuestionSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single TestQuestion model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new TestQuestion model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new TestQuestion();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing TestQuestion model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing TestQuestion model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    public function actionCreateDebug($id)
    {
        $model = $this->findModel($id);

        $connection = Yii::$app->db;
        $connection->createCommand()->insert('test_question_answers', [
            'id_question' => $id,
            'text' => 'А) Варіант відповіді',
            'pos' => 10,
            'is_correct' => 1,
        ])->execute();
        $connection->createCommand()->insert('test_question_answers', [
            'id_question' => $id,
            'text' => 'Б) Варіант відповіді',
            'pos' => 20,
            'is_correct' => 0,
        ])->execute();
        $connection->createCommand()->insert('test_question_answers', [
            'id_question' => $id,
            'text' => 'В) Варіант відповіді',
            'pos' => 20,
            'is_correct' => 0,
        ])->execute();
        $connection->createCommand()->insert('test_question_answers', [
            'id_question' => $id,
            'text' => 'Г) Варіант відповіді',
            'pos' => 20,
            'is_correct' => 0,
        ])->execute();

        return $this->redirect(['/test-question-answer', 'TestQuestionAnswerSearch[id_question]' => $model->id]);
    }

    /**
     * Finds the TestQuestion model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return TestQuestion the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = TestQuestion::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

backend/views/test-question/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model common\models\TestQuestion */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="test-question-form box box-primary">
    <?php $form = ActiveForm::begin(); ?>
    <div class="box-body table-responsive">

        <?= $form->field($model, 'id_test')->textInput() ?>

        <?= $form->field($model, 'text')->textarea(['rows' => 6]) ?>

        <?= $form->field($model, 'pos')->textInput() ?>

        <?= $form->field($model, 'cost')->textInput() ?>

    </div>
    <div class="box-footer">
        <?= Html::submitButton(Yii::t('backend/test', 'Save'), ['class' => 'btn btn-success btn-flat']) ?>
    </div>
    <?php ActiveForm::end(); ?>
</div>

backend/views/test-question/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model backend\models\TestQuestionSearch */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="test-question-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <?= $form->field($model, 'id') ?>

    <?= $form->field($model, 'id_test') ?>

    <?= $form->field($model, 'text') ?>

    <?= $form->field($model, 'pos') ?>

    <?= $form->field($model, 'cost') ?>

    <?php // echo $form->field($model, 'timestamp') ?>

    <div class="form-group">
        <?= Html::submitButton(Yii::t('backend/test', 'Search'), ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton(Yii::t('backend/test', 'Reset'), ['class' => 'btn btn-default']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

backend/views/test-question/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model common\models\TestQuestion */

$this->title = Yii::t('backend/test', 'Create Test Question');
$this->params['breadcrumbs'][] = ['label' => Yii::t('backend/test', 'Test Questions'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="test-question-create">

    <?= $this->render('_form', [
    'model' => $model,
    ]) ?>

</div>

backend/views/test-question/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel backend\models\TestQuestionSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('backend/test', 'Test Questions');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="test-question-index box box-primary">
    <div class="box-header with-border">
        <?= Html::a(Yii::t('backend/test', 'Create Test Question'), ['create'], ['class' => 'btn btn-success btn-flat']) ?>
    </div>
    <div class="box-body table-responsive no-padding">
        <?php // echo $this->render('_search', ['model' => $searchModel]); ?>
        <?= GridView::widget([
            'dataProvider' => $dataProvider,
            'filterModel' => $searchModel,
            'layout' => "{items}\n{summary}\n{pager}",
            'columns' => [
                ['class' => 'yii\grid\SerialColumn'],

                'id',
                'id_test',
                'text:ntext',
                'pos',
                'cost',
                // 'timestamp',

                ['class' => 'yii\grid\ActionColumn'],
            ],
        ]); ?>
    </div>
</div>

backend/views/test-question/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model common\models\TestQuestion */

$this->title = Yii::t('backend/test', 'Update {modelClass}: ', [
    'modelClass' => 'Test Question',
]) . $model->id;
$this->params['breadcrumbs'][] = ['label' => Yii::t('backend/test', 'Test Questions'), 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = Yii::t('backend/test', 'Update');
?>
<div class="test-question-update">

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

backend/views/test-question/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model common\models\TestQuestion */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => Yii::t('backend/test', 'Test Questions'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="test-question-view box box-primary">
    <div class="box-header">
        <?= Html::a(Yii::t('backend/test', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary btn-flat']) ?>
        <?= Html::a(Yii::t('backend/test', 'Delete'), ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger btn-flat',
            'data' => [
                'confirm' => Yii::t('backend/test', 'Are you sure you want to delete this item?'),
                'method' => 'post',
            ],
        ]) ?>

        <?= Html::a(Yii::t('backend/test', 'To the Test Question Answers'), ['/test-question-answer', 'TestQuestionAnswerSearch[id_question]' => $model->id], ['class'=>'btn btn-success pull-right']) ?>
        <?= Html::a(Yii::t('backend/test', 'Create Debug Test Question Answers'), ['/test-question/create-debug', 'id' => $model->id], ['class'=>'btn btn-success pull-right', 'style' => 'margin-right:10px']) ?>
    </div>
    <div class="box-body table-responsive no-padding">
        <?= DetailView::widget([
            'model' => $model,
            'attributes' => [
                'id',
                'id_test',
                'text:ntext',
                'pos',
                'cost',
                'timestamp',
            ],
        ]) ?>
    </div>
</div>